/*!
 * push.js
 * =======
 * A compact, cross-browser solution for Javascript desktop notifications
 *
 * Credits
 * -------
 * Tsvetan Tsvetkov (ttsvetko)
 * Alex Gibson (alexgibson)
 *
 * License
 * -------
 *
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 Tyler Nickerson
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */
(function(b,a){if(typeof define==="function"&&define.amd){define(function(){return new (a(b,b.document))()})}else{if(typeof module!=="undefined"&&module.exports){module.exports=(a(b,b.document))()}else{b.Push=new (a(b,b.document))()}}})(window!=="undefined"?window:self,function(b,c){var a=function(){var n=this,g=function(o){return o===undefined},e=function(o){return o&&o.constructor===String},f=function(o){return o&&o.constructor===Function},k=false,m=[],j=function(o){if(o.close){o.close()}else{if(o.cancel){o.cancel()}else{if(b.external&&b.external.msIsSiteMode){b.external.msSiteModeClearIconOverlay()}}}},i=function(){n.count=m.length},h=function(p,o){o=o||{};if(b.Notification){notification=new b.Notification(p,{icon:(e(o.icon)||g(o.icon))?o.icon:o.icon.x32,body:o.body,tag:o.tag})}else{if(b.webkitNotifications){notification=win.webkitNotifications.createNotification(o.icon,p,o.body);notification.show()}else{if(navigator.mozNotification){notification=navigator.mozNotification.createNotification(p,o.body,o.icon);notification.show()}else{if(win.external&&win.external.msIsSiteMode()){b.external.msSiteModeClearIconOverlay();b.external.msSiteModeSetIconOverlay(((e(o.icon)||g(o.icon))?o.icon:o.icon.x16),p);b.external.msSiteModeActivate();notification={}}}}}wrapper={close:function(){j(notification)}};if(o.timeout){setTimeout(function(){wrapper.close()},o.timeout)}if(f(o.onShow)){notification.addEventListener("show",o.onShow)}if(f(o.onError)){notification.addEventListener("error",o.onError)}if(f(o.onClick)){notification.addEventListener("click",o.onClick)}if(f(o.onClose)){notification.addEventListener("close",o.onClose);notification.addEventListener("cancel",o.onClose)}m.push(notification);i();return wrapper},l={DEFAULT:"default",GRANTED:"granted",DENIED:"denied"},d=[l.GRANTED,l.DEFAULT,l.DENIED];n.Permission=l;n.count=0;n.Permission.request=function(o,p){if(!n.isSupported){console.error("This browser is not supported");return}callback=function(q){switch(q){case n.Permission.GRANTED:k=true;if(o){o()}break;case n.Permission.DENIED:k=false;if(p){p()}break}};if(b.Notification&&b.Notification.requestPermission){Notification.requestPermission(callback)}else{if(b.webkitNotifications&&b.webkitNotifications.checkPermission){b.webkitNotifications.requestPermission(callback)}}};n.Permission.has=function(){return k};n.Permission.get=function(){var o;if(!n.isSupported){return}if(b.Notification&&b.Notification.permissionLevel){o=b.Notification.permissionLevel}else{if(b.webkitNotifications&&b.webkitNotifications.checkPermission){o=d[b.webkitNotifications.checkPermission()]}else{if(b.Notification&&b.Notification.permission){o=b.Notification.permission}else{if(navigator.mozNotification){o=d.GRANTED}else{if(b.external&&b.external.msIsSiteMode()!==undefined){o=b.external.msIsSiteMode()?l.GRANTED:l.DEFAULT}}}}}return o};n.isSupported=(function(){var o=false;try{o=!!(b.Notification||b.webkitNotifications||navigator.mozNotification||(b.external&&b.external.msIsSiteMode()!==undefined))}catch(p){}return o})();n.create=function(q,o){var p,r;if(!n.isSupported){console.error("PushError: push.js is incompatible with self browser.");return}if(typeof q!=="string"){throw"PushError: Title of notification must be a string"}if(!n.Permission.has()){n.Permission.request(function(){return h(q,o)})}else{return h(q,o)}};n.close=function(o){var p,q;for(p=0;p<m.length;p++){q=m[p];if(q.tag===o){j(q);m.splice(p,1);i();return}}};n.clear=function(){var o;for(o=0;o<m.length;o++){j(m[o])}m=[];i()}};return a});